//! `/unsubscribe` endpoint JSON-RPC wrapper

use crate::prelude::*;
use serde::{Deserialize, Serialize};

/// Request to unsubscribe from events relating to a given query.
#[derive(Clone, Debug, Deserialize, Eq, PartialEq, Serialize)]
pub struct Request {
    pub query: String,
}

impl Request {
    /// Unsubscribe from all events generated by the given query.
    pub fn new(query: String) -> Self {
        Self { query }
    }
}

impl crate::Request for Request {
    type Response = Response;

    fn method(&self) -> crate::Method {
        crate::Method::Unsubscribe
    }
}

/// Status responses
#[derive(Clone, Debug, Deserialize, Serialize)]
pub struct Response {}

impl crate::Response for Response {}
